// Copyright (C) 1998-1999 Scott Cutler
// Please see the "readme.txt" file for license details

#include "include.h"

FX_ENTRY void FX_CALL grAlphaControlsITRGBLighting( FxBool enable ) {
	log("Error: unsupported function grAlphaControlsITRGBLighting");

}

FX_ENTRY void FX_CALL grChromakeyValue( GrColor_t value ) {
	vlog("Called grChromakeyValue: color=" << value);

	Voodoo.colorKey = value;
}


FX_ENTRY void FX_CALL grChromakeyMode( GrChromakeyMode_t mode ) {
	vlog("Called grChromakeyMode: mode=" << mode);

	_exebuffer->Flush();


	if (mode == GR_CHROMAKEY_ENABLE) {
		DX.D3DD->SetRenderState(D3DRENDERSTATE_COLORKEYENABLE, TRUE);
		Voodoo.colorkeyon = 1;
	} else if (mode == GR_CHROMAKEY_DISABLE) {
		DX.D3DD->SetRenderState(D3DRENDERSTATE_COLORKEYENABLE, FALSE);
		Voodoo.colorkeyon = 0;
	}

}


FX_ENTRY void FX_CALL grAlphaTestReferenceValue( GrAlpha_t value ) {
	vlog("Called grAlphaTestReferenceValue: value=" << (int)value);

	// Zelda text thing
//	return;

	_exebuffer->Flush();

	DX.D3DD->SetRenderState(D3DRENDERSTATE_ALPHATESTENABLE, TRUE);
	DX.D3DD->SetRenderState(D3DRENDERSTATE_ALPHAREF, (DWORD)value);
}


FX_ENTRY void FX_CALL grAlphaBlendFunction(GrAlphaBlendFnc_t rgb_sf, GrAlphaBlendFnc_t rgb_df, GrAlphaBlendFnc_t alpha_sf, GrAlphaBlendFnc_t alpha_df) {

	vlog("Called grAlphaBlendFunction: rgb_sf=" << rgb_sf << " rgb_df=" << rgb_df << " alpha_sf=" << alpha_sf << " alpha_df=" << alpha_df);

	// Zelda text thing
//	return;

	_exebuffer->Flush();

	DX.D3DD->SetRenderState(D3DRENDERSTATE_SRCBLEND, src_blend_lut[rgb_sf]);

	DX.D3DD->SetRenderState(D3DRENDERSTATE_DESTBLEND, dst_blend_lut[rgb_df]);
}


FX_ENTRY void FX_CALL grAlphaTestFunction( GrCmpFnc_t function ) {
	vlog("Called grAlphaTestFunction");
/*
 D3DCMP_NEVER;
D3DCMP_LESS;
 D3DCMP_EQUAL;
= D3DCMP_LESSEQUAL;
 = D3DCMP_GREATER;
] = D3DCMP_NOTEQUAL;
= D3DCMP_GREATEREQUAL;
= D3DCMP_ALWAYS;
*/
	// Zelda text thing
//	return;

	_exebuffer->Flush();

	if (DX.D3DHD.dpcTriCaps.dwAlphaCmpCaps & atest_caps_lut[function]) 
		DX.D3DD->SetRenderState(D3DRENDERSTATE_ALPHAFUNC, atest_lut[function]);
	else
		log("  Sorry, unsupported alpha test function: " << function);

}


FX_ENTRY void FX_CALL grColorMask( FxBool rgb, FxBool a ) {
	vlog("Called grColorMask: value=" << rgb);

	_exebuffer->Flush();

	DWORD mask = 0;

	if (rgb == FXTRUE) mask |= 0x00FFFFFF;
	if (a == FXTRUE) mask |= 0xFF000000;

	DX.D3DD->SetRenderState(D3DRENDERSTATE_PLANEMASK, mask);

}


FX_ENTRY void FX_CALL grAlphaCombine(GrCombineFunction_t function, GrCombineFactor_t factor,
               GrCombineLocal_t local, GrCombineOther_t other,
               FxBool invert
               ) {
	vlog("Called grAlphaCombine");

}


FX_ENTRY void FX_CALL grConstantColorValue( GrColor_t value ) {
	vlog("Called grConstantColorValue");

	Voodoo.constantColor = colorconv(value);
	Voodoo.CCA = ((value & 0xFF000000) >> 24) / 255.0f;
	Voodoo.CCR = ((value & 0x00FF0000) >> 16) / 255.0f;
	Voodoo.CCG = ((value & 0x0000FF00) >> 8) / 255.0f;
	Voodoo.CCB = (value & 0x000000FF) / 255.0f;

	_exebuffer->Flush();

	DX.D3DD->SetRenderState(D3DRENDERSTATE_TEXTUREFACTOR, Voodoo.constantColor);
}

FX_ENTRY void FX_CALL grConstantColorValue4( float a, float r, float g, float b ) {

//	Voodoo.constantColor = colorconv(a, r, g, b);
	Voodoo.CCA = a;
	Voodoo.CCR = r;
	Voodoo.CCG = g;
	Voodoo.CCB = b;

}


FX_ENTRY void FX_CALL grColorCombine(
               GrCombineFunction_t function, GrCombineFactor_t factor,
               GrCombineLocal_t local, GrCombineOther_t other,
               FxBool invert ) {
	vlog("Called grColorCombine: func=" << function << "  fac=" << factor << "  local=" << local << "  other=" << other);



	// Reset defaults in case a previous call changed them.
	_exebuffer->SetColorArg1(D3DTA_TEXTURE);
	_exebuffer->SetColorArg2(D3DTA_CURRENT);

	// Ok, get ready for massive nastiness :-).
	switch (function) {
	case GR_COMBINE_FUNCTION_LOCAL:
		switch (local) {
		case GR_COMBINE_LOCAL_ITERATED:
			// Mario Kart flag
			// Zelda text

			getcolor = iterated;

			if (!Settings.atifix) 
				_exebuffer->SetColorOp(D3DTOP_SELECTARG2);
			else
				_exebuffer->SetColorOp(D3DTOP_SELECTARG1);

//			_exebuffer->SetColorOp(D3DTOP_SELECTARG2);

			break;
		case GR_COMBINE_LOCAL_CONSTANT:
			getcolor = constant;
			_exebuffer->SetColorOp(D3DTOP_SELECTARG2);
			break;
		default:
			log("Error, unsupported color combine mode: (" << function << ", " << factor << ", " << local << ", " << other << ")");
			break;
		}
		break;
	case GR_COMBINE_FUNCTION_SCALE_OTHER:
		switch (factor) {
		case GR_COMBINE_FACTOR_ZERO:
			getcolor = black;
			_exebuffer->SetColorOp(D3DTOP_SELECTARG1);
			break;
		case GR_COMBINE_FACTOR_LOCAL:
			switch (local) {
			case GR_COMBINE_LOCAL_ITERATED:
				switch (other) {
				case GR_COMBINE_OTHER_ITERATED:
					getcolor = iterated2;
					_exebuffer->SetColorOp(D3DTOP_SELECTARG2);
					break;
				case GR_COMBINE_OTHER_CONSTANT:
					getcolor = iterconst;
					_exebuffer->SetColorOp(D3DTOP_SELECTARG2);
					break;
				case GR_COMBINE_OTHER_TEXTURE:
					// Waverace sky ?
					getcolor = iterated;
					_exebuffer->SetColorOp(D3DTOP_MODULATE);

//getcolor = white;
//SetColorOp(D3DTOP_SELECTARG1);

					break;
				default:
					log("Error, unsupported color combine mode: (" << function << ", " << factor << ", " << local << ", " << other << ")");
					break;
				}
				break;
			case GR_COMBINE_LOCAL_CONSTANT:
				switch (other) {
				case GR_COMBINE_OTHER_ITERATED:
					getcolor = iterconst;
					_exebuffer->SetColorOp(D3DTOP_SELECTARG2);
					break;
				case GR_COMBINE_OTHER_TEXTURE:
					getcolor = constant;
					_exebuffer->SetColorOp(D3DTOP_MODULATE);
					break;
				case GR_COMBINE_OTHER_CONSTANT:
					getcolor = constant2;
					_exebuffer->SetColorOp(D3DTOP_SELECTARG2);
					break;
				default:
					log("Error, unsupported color combine mode: (" << function << ", " << factor << ", " << local << ", " << other << ")");
					break;
				}
				break;
			default:
				log("Error, unsupported color combine mode: (" << function << ", " << factor << ", " << local << ", " << other << ")");
				break;
			}
			break;
		case GR_COMBINE_FACTOR_LOCAL_ALPHA:
			switch (local) {
			case GR_COMBINE_LOCAL_CONSTANT:
				switch (other) {
				case GR_COMBINE_OTHER_TEXTURE:
					log("Error, unsupported color combine mode: (" << function << ", " << factor << ", " << local << ", " << other << ")");

					// Gods
					break;
				default:
					log("Error, unsupported color combine mode: (" << function << ", " << factor << ", " << local << ", " << other << ")");
					break;
				}
				break;
			default:
				log("Error, unsupported color combine mode: (" << function << ", " << factor << ", " << local << ", " << other << ")");
				break;
			}
			break;
		case GR_COMBINE_FACTOR_ONE:
			switch (other) {
			case GR_COMBINE_OTHER_ITERATED:
				getcolor = iterated;
				_exebuffer->SetColorOp(D3DTOP_SELECTARG2);
				break;
			case GR_COMBINE_OTHER_TEXTURE:
				getcolor = iterated;
				_exebuffer->SetColorOp(D3DTOP_SELECTARG1);
				break;
			case GR_COMBINE_OTHER_CONSTANT:
				getcolor = constant;
				_exebuffer->SetColorOp(D3DTOP_SELECTARG2);
				break;
			default:
				log("Error, unsupported color combine mode: (" << function << ", " << factor << ", " << local << ", " << other << ")");
				break;
			}
			break;
		default:
			log("Error, unsupported color combine mode: (" << function << ", " << factor << ", " << local << ", " << other << ")");
			break;
		}
		break;
	case GR_COMBINE_FUNCTION_SCALE_OTHER_MINUS_LOCAL_ADD_LOCAL:
		switch (factor) {
		case GR_COMBINE_FACTOR_TEXTURE_ALPHA:
			switch (local) {
			case GR_COMBINE_LOCAL_ITERATED:
				switch (other) {
				case GR_COMBINE_OTHER_TEXTURE:
					getcolor = iterated;

					if (Settings.colorop_blendtexturealpha == 0) {
						_exebuffer->SetColorOp(D3DTOP_SELECTARG2);
					} else if (Settings.colorop_blendtexturealpha == 1) {
						_exebuffer->SetColorOp(D3DTOP_BLENDTEXTUREALPHA);
					} else {
						if (DX.D3DHD.dwTextureOpCaps & D3DTEXOPCAPS_BLENDTEXTUREALPHA) {
							_exebuffer->SetColorOp(D3DTOP_BLENDTEXTUREALPHA);
						} else {
							_exebuffer->SetColorOp(D3DTOP_SELECTARG2);
						}
					}
					break;
				default:
					log("Error, unsupported color combine mode: (" << function << ", " << factor << ", " << local << ", " << other << ")");
					break;
				}
				break;
			default:
				log("Error, unsupported color combine mode: (" << function << ", " << factor << ", " << local << ", " << other << ")");
				break;
			}
			break;
		case GR_COMBINE_FACTOR_TEXTURE_RGB:
			switch (local) {
			case GR_COMBINE_LOCAL_ITERATED:
				switch (other) {
				case GR_COMBINE_OTHER_CONSTANT:

					// Shiny Mario!
					getcolor = iterated;

					if (Settings.colorop_add == 0) {
						_exebuffer->SetColorOp(D3DTOP_SELECTARG2);
					} else if (Settings.colorop_add == 1) {
						_exebuffer->SetColorOp(D3DTOP_ADD);
					} else {
						if (DX.D3DHD.dwTextureOpCaps & D3DTEXOPCAPS_ADD) {
							_exebuffer->SetColorOp(D3DTOP_ADD);
						} else {
							_exebuffer->SetColorOp(D3DTOP_SELECTARG2);
						}
					}
				//	Voodoo.constantColor = 0xFFFF0000;
				//	getcolor = constant;
				//	SetColorOp(D3DTOP_SELECTARG2);

					break;
				default:
					log("Error, unsupported color combine mode: (" << function << ", " << factor << ", " << local << ", " << other << ")");
					break;
				}
				break;
			case GR_COMBINE_LOCAL_CONSTANT:
				switch (other) {
				case GR_COMBINE_OTHER_ITERATED:
					// Zelda 64... needs work!
					getcolor = iterated;

					_exebuffer->SetColorOp(D3DTOP_MODULATE);

/*
					if (Settings.colorop_blendtexturealpha == 0) {
						SetColorOp(D3DTOP_MODULATE);

					if (DX.D3DHD.dwTextureOpCaps & D3DTEXOPCAPS_BLENDTEXTUREALPHA) {
//						DX.D3DD->SetRenderState(D3DRENDERSTATE_SRCBLEND, D3DBLEND_SRCCOLOR);
						SetColorOp(D3DTOP_MODULATE);
					} else {
//						DX.D3DD->SetRenderState(D3DRENDERSTATE_SRCBLEND, D3DBLEND_SRCCOLOR);
						SetColorOp(D3DTOP_MODULATE);
//						DX.D3DD->SetTextureStageState(0, D3DTSS_COLOROP, D3DTOP_MODULATE);
//						DX.D3DD->SetTextureStageState(0, D3DTSS_COLOROP, D3DTOP_DISABLE);
					}
*/
					break;
				default:
					log("Error, unsupported color combine mode: (" << function << ", " << factor << ", " << local << ", " << other << ")");
					break;
				}
				break;
			default:
				log("Error, unsupported color combine mode: (" << function << ", " << factor << ", " << local << ", " << other << ")");
				break;
			}
			break;
		default:
			log("Error, unsupported color combine mode: (" << function << ", " << factor << ", " << local << ", " << other << ")");
			break;
		}
		break;
	case GR_COMBINE_FUNCTION_SCALE_OTHER_ADD_LOCAL:
		switch (factor) {
		case GR_COMBINE_FACTOR_ONE:
			switch (local) {
			case GR_COMBINE_LOCAL_ITERATED:
				switch (other) {
				case GR_COMBINE_OTHER_TEXTURE:
					// Mario Kart
					getcolor = iterated;

					if (Settings.colorop_add == 0) {
						_exebuffer->SetColorOp(D3DTOP_SELECTARG1);
					} else if (Settings.colorop_add == 1) {
						_exebuffer->SetColorOp(D3DTOP_ADD);
					} else {
						if (DX.D3DHD.dwTextureOpCaps & D3DTEXOPCAPS_ADD) {
							_exebuffer->SetColorOp(D3DTOP_ADD);
						} else {
							_exebuffer->SetColorOp(D3DTOP_SELECTARG1);
						}
					}

					break;
				default:
					log("Error, unsupported color combine mode: (" << function << ", " << factor << ", " << local << ", " << other << ")");
					break;
				}
				break;
			default:
				log("Error, unsupported color combine mode: (" << function << ", " << factor << ", " << local << ", " << other << ")");
				break;
			}
			break;
		default:
			log("Error, unsupported color combine mode: (" << function << ", " << factor << ", " << local << ", " << other << ")");
			break;
		}
		break;
	case GR_COMBINE_FUNCTION_SCALE_OTHER_ADD_LOCAL_ALPHA:
		switch (factor) {
		case GR_COMBINE_FACTOR_LOCAL:
			switch (local) {
			case GR_COMBINE_LOCAL_ITERATED:
				switch (other) {
				case GR_COMBINE_OTHER_TEXTURE:
						getcolor = iterated;
						_exebuffer->SetColorOp(D3DTOP_MODULATE);
						break;
				default:
					log("Error, unsupported color combine mode: (" << function << ", " << factor << ", " << local << ", " << other << ")");
					break;
				}
				break;
			default:
				log("Error, unsupported color combine mode: (" << function << ", " << factor << ", " << local << ", " << other << ")");
				break;
			}
			break;
		default:
			log("Error, unsupported color combine mode: (" << function << ", " << factor << ", " << local << ", " << other << ")");
			break;
		}
		break;
	default:
		log("Error, unsupported color combine mode: (" << function << ", " << factor << ", " << local << ", " << other << ")");
		break;
	}

}



FX_ENTRY void FX_CALL guAlphaSource( GrAlphaSource_t mode ) {
	vlog("Called guAlphaSource: mode=" << mode);

	
	_exebuffer->SetAlphaArg1(D3DTA_TEXTURE);
	_exebuffer->SetAlphaArg2(D3DTA_CURRENT);

	switch (mode) {
	case GR_ALPHASOURCE_CC_ALPHA:
		_exebuffer->SetAlphaOp(D3DTOP_SELECTARG1);
		_exebuffer->SetAlphaArg1(D3DTA_TFACTOR);

//		grColorCombine(GR_COMBINE_FUNCTION_LOCAL, GR_COMBINE_FACTOR_ONE, GR_COMBINE_LOCAL_ITERATED, GR_COMBINE_OTHER_NONE, FXFALSE);
//		log("  Unsupported guAlphaSource mode: GR_ALPHASOURCE_CC_ALPHA");
		break;
	case GR_ALPHASOURCE_ITERATED_ALPHA:
		_exebuffer->SetAlphaOp(D3DTOP_SELECTARG2);
		break;
	case GR_ALPHASOURCE_TEXTURE_ALPHA:
		_exebuffer->SetAlphaOp(D3DTOP_SELECTARG1);
		break;
	case GR_ALPHASOURCE_TEXTURE_ALPHA_TIMES_ITERATED_ALPHA:
		// Zelda text
		if (Settings.alphaop_modulate == 0) {
			_exebuffer->SetAlphaOp(D3DTOP_SELECTARG2);
		} else {
			_exebuffer->SetAlphaOp(D3DTOP_MODULATE);
		}
		break;
	}

}



FX_ENTRY void FX_CALL guColorCombineFunction( GrColorCombineFnc_t fnc ) {
	vlog("Called guColorCombineFunction: fnc=" << fnc);

	_exebuffer->Flush();

//	return;
	switch (fnc) {
//	case GR_COLORCOMBINE_ZERO:							break;
	case GR_COLORCOMBINE_ITRGB:							grColorCombine(GR_COMBINE_FUNCTION_LOCAL, GR_COMBINE_FACTOR_ONE, GR_COMBINE_LOCAL_ITERATED, GR_COMBINE_OTHER_NONE, FXFALSE); break;
//	case GR_COLORCOMBINE_ITRGB_DELTA0:					// Need to implement
	case GR_COLORCOMBINE_ITRGB_DELTA0:					break;

		// Mario water...
	case GR_COLORCOMBINE_DECAL_TEXTURE:					grColorCombine(GR_COMBINE_FUNCTION_SCALE_OTHER, GR_COMBINE_FACTOR_ONE, GR_COMBINE_LOCAL_NONE, GR_COMBINE_OTHER_TEXTURE, FXFALSE); break;

//	case GR_COLORCOMBINE_TEXTURE_TIMES_CCRGB:			break;
	case GR_COLORCOMBINE_TEXTURE_TIMES_ITRGB:			grColorCombine(GR_COMBINE_FUNCTION_SCALE_OTHER, GR_COMBINE_FACTOR_LOCAL, GR_COMBINE_LOCAL_ITERATED, GR_COMBINE_OTHER_TEXTURE, FXFALSE); break;
//	case GR_COLORCOMBINE_TEXTURE_TIMES_ITRGB_DELTA0:	// Need to implement
	case GR_COLORCOMBINE_TEXTURE_TIMES_ITRGB_DELTA0:	break;

//	case GR_COLORCOMBINE_TEXTURE_TIMES_ITRGB_ADD_ALPHA:	break;
//	case GR_COLORCOMBINE_TEXTURE_TIMES_ALPHA:			break;
	case GR_COLORCOMBINE_TEXTURE_ADD_ITRGB:				grColorCombine(GR_COMBINE_FUNCTION_SCALE_OTHER_ADD_LOCAL, GR_COMBINE_FACTOR_ONE, GR_COMBINE_LOCAL_ITERATED, GR_COMBINE_OTHER_TEXTURE, FXFALSE); break;
//	case GR_COLORCOMBINE_TEXTURE_SUB_ITRGB:				break;
//	case GR_COLORCOMBINE_CCRGB:							break;
//	case GR_COLORCOMBINE_CCRGB_BLEND_ITRGB_ON_TEXALPHA:	break;
//	case GR_COLORCOMBINE_DIFF_SPEC_A:					break;
//	case GR_COLORCOMBINE_DIFF_SPEC_B:					break;
//	case GR_COLORCOMBINE_ONE:							break;
	default:											
		grColorCombine(GR_COMBINE_FUNCTION_SCALE_OTHER, GR_COMBINE_FACTOR_ZERO, GR_COMBINE_LOCAL_NONE, GR_COMBINE_OTHER_NONE, FXFALSE); 
		log("  Error in guColorCombineFunction, unsupported mode: " << fnc);
		break;
	}
}
