// Copyright (C) 1998-1999 Scott Cutler
// Please see the "readme.txt" file for license details

#include "include.h"

//D3DTLVERTEX tri[3];
D3DTLVERTEX vert;

D3DTLVERTEX *tri;



FX_ENTRY void FX_CALL grDrawPlanarPolygonVertexList( int nverts, const GrVertex vlist[] ) {
	vvlog("Called grDrawPlanarPolygonVertexList");

	_exebuffer->Flush();

	DX.D3DD->Begin(D3DPT_TRIANGLEFAN, D3DFVF_TLVERTEX, D3DDP_DONOTLIGHT);
	for (int i=0; i<nverts; i++) {
		vconv(vlist[i], vert);
		DX.D3DD->Vertex((LPVOID)&vert);
	}
	DX.D3DD->End(0);
}



FX_ENTRY void FX_CALL grDrawTriangle(const GrVertex *a, const GrVertex *b, const GrVertex *c ) {
	vvlog("Called grDrawTriangle");

	tri = _exebuffer->GetBuffer(1);

	vconv(*a, tri[0]);
	vconv(*b, tri[1]);
	vconv(*c, tri[2]);
}


FX_ENTRY void FX_CALL grDrawPolygonVertexList( int nverts, const GrVertex vlist[] ) {
	vvlog("Called grDrawPolygonVertexList");


	_exebuffer->Flush();

	DX.D3DD->Begin(D3DPT_TRIANGLEFAN, D3DFVF_TLVERTEX, D3DDP_DONOTLIGHT);
	for (int i=0; i<nverts; i++) {
		vconv(vlist[i], vert);
		DX.D3DD->Vertex((LPVOID)&vert);
	}
	DX.D3DD->End(0);
}


FX_ENTRY void FX_CALL grAADrawPolygonVertexList( int nverts, const GrVertex vlist[] ) {
	vvlog("Called grDrawPolygonVertexList");

	_exebuffer->Flush();

	DX.D3DD->Begin(D3DPT_TRIANGLEFAN, D3DFVF_TLVERTEX, D3DDP_DONOTLIGHT);
	for (int i=0; i<nverts; i++) {
		vconv(vlist[i], vert);
		DX.D3DD->Vertex((LPVOID)&vert);
	}
	DX.D3DD->End(0);
}


FX_ENTRY void FX_CALL grAADrawTriangle( const GrVertex *a, const GrVertex *b, const GrVertex *c, FxBool ab_antialias, FxBool bc_antialias, FxBool ca_antialias) {
	vvlog("Called grAADrawTriangle");

	tri = _exebuffer->GetBuffer(1);

	vconv(*a, tri[0]);
	vconv(*b, tri[1]);
	vconv(*c, tri[2]);
}


FX_ENTRY void FX_CALL grDrawLine( const GrVertex *v1, const GrVertex *v2 ) {
	vvlog("Called grDrawLine");

	_exebuffer->Flush();

	DX.D3DD->Begin(D3DPT_LINELIST, D3DFVF_TLVERTEX, D3DDP_DONOTLIGHT);
		vconv(*v1, vert);
		DX.D3DD->Vertex((LPVOID)&vert);
		vconv(*v2, vert);
		DX.D3DD->Vertex((LPVOID)&vert);
	DX.D3DD->End(0);
}

FX_ENTRY void FX_CALL grAADrawLine( const GrVertex *v1, const GrVertex *v2 ) {
	vvlog("Called grDrawLine");

	_exebuffer->Flush();

	DX.D3DD->Begin(D3DPT_LINELIST, D3DFVF_TLVERTEX, D3DDP_DONOTLIGHT);
		vconv(*v1, vert);
		DX.D3DD->Vertex((LPVOID)&vert);
		vconv(*v2, vert);
		DX.D3DD->Vertex((LPVOID)&vert);
	DX.D3DD->End(0);
}

FX_ENTRY void FX_CALL grDrawPoint( const GrVertex *pt ) {
	vvlog("Called grDrawPoint");

	_exebuffer->Flush();

	DX.D3DD->Begin(D3DPT_POINTLIST, D3DFVF_TLVERTEX, D3DDP_DONOTLIGHT);
		vconv(*pt, vert);
		DX.D3DD->Vertex((LPVOID)&vert);
	DX.D3DD->End(0);
}

FX_ENTRY void FX_CALL grAADrawPoint( const GrVertex *pt ) {
	vvlog("Called grDrawPoint");

	_exebuffer->Flush();

	DX.D3DD->Begin(D3DPT_POINTLIST, D3DFVF_TLVERTEX, D3DDP_DONOTLIGHT);
		vconv(*pt, vert);
		DX.D3DD->Vertex((LPVOID)&vert);
	DX.D3DD->End(0);
}

FX_ENTRY void FX_CALL grDrawPlanarPolygon( int nverts, const int ilist[], const GrVertex vlist[] ) {
	vvlog("Called grDrawPlanarPolygon");

	_exebuffer->Flush();

	DX.D3DD->Begin(D3DPT_TRIANGLEFAN, D3DFVF_TLVERTEX, D3DDP_DONOTLIGHT);
	for (int i=0; i<nverts; i++) {
		vconv(vlist[ilist[i]], vert);
		DX.D3DD->Vertex((LPVOID)&vert);
	}
	DX.D3DD->End(0);
}


FX_ENTRY void FX_CALL guDrawTriangleWithClip(const GrVertex *a, const GrVertex *b, const GrVertex *c ) {
	vvlog("Called guDrawTriangleWithClip");

	tri = _exebuffer->GetBuffer(1);

	vconv(*a, tri[0]);
	vconv(*b, tri[1]);
	vconv(*c, tri[2]);
}
