// Copyright (C) 1998-1999 Scott Cutler
// Please see the "readme.txt" file for license details

#include "include.h"


TexList::TexList() {
	vlog("Called TexList::TexList");

	int i;

	for (i=0; i<MAX_TEXTURES; i++) _list[i] = 0;
}

TexList::~TexList() {
	vlog("Called TexList::~TexList");

	for (int i=0; i<MAX_TEXTURES; i++) if (_list[i]) delete _list[i];
}

void TexList::AddTex(const FxU32 address, const GrTexInfo &t) {
	vlog("Called TexList::AddTex");

	Tex *newtex = new Tex(address, t);

	if (newtex->tex()) {
		DeleteTex(address);

		_list[address>>10] = newtex;
	}
}

Tex * TexList::GetTex(const FxU32 address, const GrTexInfo & t) {
	vlog("Called TexList::GetTex");

	if (_list[address>>10]) {
		return _list[address>>10];
	}

//	GrTexInfo info = t;

//	info.data = (void *)address;

//	AddTex(address, info);

//	return GetTex(address, info);
	return 0;
}

void TexList::DeleteTex(const FxU32 address) {
	vlog("Called TexList::DeleteOverwritten");

	if (_list[address>>10]) {
		vlog("Deleted texture at address " << _list[address>>10]);

		delete _list[address>>10];

		if (Voodoo.curtex == _list[address>>10]) {
			Voodoo.curtex = 0;
			Voodoo.texture = NO_TEXTURE;
			vconv = vconv_lut[depthbuf_lut[Voodoo.dbMode]][Voodoo.origin][Voodoo.texture];
		}

		_list[address>>10] = 0;
	}

}