// Copyright (C) 1998-1999 Scott Cutler
// Please see the "readme.txt" file for license details

#include "include.h"

#define CHOPBITS 10

TexList::TexList() {
	vlog("Called TexList::TexList");

	int i, num= Voodoo.tmuRam << 20 >> CHOPBITS;

	_list = new TexNode*[num];

	for (i=0; i<num; i++) {
		_list[i] = new TexNode(0);
		_list[i]->next = 0;
		_list[i]->prev = 0;
	}

}

TexList::~TexList() {
	vlog("Called TexList::~TexList");

//	for (int i=0; i<MAX_TEXTURES; i++) delete _list[i];

	delete [] _list;
}

void TexList::AddTex(const FxU32 address, const GrTexInfo &t) {
	vlog("Called TexList::AddTex");

	Tex *newtex = new Tex(address, t);
	TexNode *newtexnode = new TexNode(newtex);

	if (newtex->tex()) {
//		DeleteOverwritten(*newtex);

		TexNode *curnode = _list[address>>10];
		while (curnode->next != 0) curnode = curnode->next;

		curnode->next = newtexnode;
		newtexnode->prev = curnode;
		newtexnode->next = 0;
	} else {
		log("Error: exceeded max texture limit");
	}

}

Tex * TexList::GetTex(const FxU32 address, const GrTexInfo & t) {
	vlog("Called TexList::GetTex");

//	return 0;

	TexNode *curnode = _list[address>>CHOPBITS];

	while (curnode->next != 0) {
		curnode = curnode->next;

		if (address == curnode->tex->base()) {
			if (curnode->tex->paletted()) curnode->tex->setpalette();
			return curnode->tex;
		}
	}

	GrTexInfo info = t;

	info.data = (void *)(Voodoo.tmuMem+address);
	AddTex(address, info);

	return GetTex(address, info);
	
//	return 0;
}

void TexList::DeleteOverwritten(const Tex &t) {
	vlog("Called TexList::DeleteOverwritten");
	int i;
	TexNode *curnode;

	for (i=0; i<Voodoo.tmuRam*1024; i++) {
		curnode = _list[i];
		while (curnode->next != 0) {
			curnode = curnode->next;

			if (intersect(*curnode->tex, t)) {
				curnode->prev->next = curnode->next;
				curnode->next->prev = curnode->prev;

				if (Voodoo.curtex == curnode->tex) {
					Voodoo.curtex = 0;
					Voodoo.texture = NO_TEXTURE;
					vconv = vconv_lut[depthbuf_lut[Voodoo.dbMode]][Voodoo.origin][Voodoo.texture];
				}

				delete curnode;
			}
		}
	}


	/*
	if (_list[i] && intersect(*_list[i], t)) {
			vlog("Deleted texture at address " << _list[i]);
			delete _list[i];
			if (_cache[i % TEX_CACHE_SIZE] == _list[i]) _cache[i % TEX_CACHE_SIZE] = 0;

			if (Voodoo.curtex == _list[i]) {
				Voodoo.curtex = 0;
				Voodoo.texture = NO_TEXTURE;
				vconv = vconv_lut[depthbuf_lut[Voodoo.dbMode]][Voodoo.origin][Voodoo.texture];
			}

			_list[i] = 0;
		}
	}
*/
}