#include "include.h"

FxBool loadsettings() {
	HKEY regkey = 0;
	DWORD type;
	char str[256];
	DWORD size = sizeof(str);

	RegCreateKey(HKEY_CURRENT_USER, "Software\\XGl200", &regkey);

	if ((RegQueryValueEx(regkey, "ver", 0, &type, (LPBYTE)&str, &size) == ERROR_SUCCESS) &&
		(strcmp((char *)str, "0.02j") == 0)) {

		size = sizeof(DWORD);

		RegQueryValueEx(regkey, "aa", 0, &type, (LPBYTE)&Settings.aa, &size);
		RegQueryValueEx(regkey, "alphaop_modulate", 0, &type, (LPBYTE)&Settings.alphaop_modulate, &size);
		RegQueryValueEx(regkey, "clamp", 0, &type, (LPBYTE)&Settings.clamp, &size);
		RegQueryValueEx(regkey, "colorop_add", 0, &type, (LPBYTE)&Settings.colorop_add, &size);
		RegQueryValueEx(regkey, "colorop_blendtexturealpha", 0, &type, (LPBYTE)&Settings.colorop_blendtexturealpha, &size);
		RegQueryValueEx(regkey, "vsync", 0, &type, (LPBYTE)&Settings.vsync, &size);
		RegQueryValueEx(regkey, "zbits", 0, &type, (LPBYTE)&Settings.zbits, &size);
		RegQueryValueEx(regkey, "model", 0, &type, (LPBYTE)&Settings.model, &size);
		RegQueryValueEx(regkey, "tmumem", 0, &type, (LPBYTE)&Settings.tmumem, &size);
		RegQueryValueEx(regkey, "backbuffers", 0, &type, (LPBYTE)&Settings.backbuffers, &size);
		RegQueryValueEx(regkey, "fps", 0, &type, (LPBYTE)&Settings.fps, &size);
		RegQueryValueEx(regkey, "priority", 0, &type, (LPBYTE)&Settings.priority, &size);
		RegQueryValueEx(regkey, "logging", 0, &type, (LPBYTE)&Settings.logging, &size);
		RegQueryValueEx(regkey, "atifix", 0, &type, (LPBYTE)&Settings.atifix, &size);

		if (!Settings.tmumem) Settings.tmumem = 4;
	} else {
		MessageBox(0, "Please run the XGl200 Configurator", "Error", MB_OK);

		return FXFALSE;
	}

	return FXTRUE;
}

FxBool getcaps() {
	LPDIRECT3DDEVICE3 D3DD;

	if (DX.D3D->CreateDevice(IID_IDirect3DHALDevice, DX.DDSRender, &D3DD, NULL)) {
		log("  Error in CreateDevice");
		return FXFALSE;
	}

	DX.D3DHD.dwSize = sizeof(D3DDEVICEDESC);
	DX.D3DSD.dwSize = sizeof(D3DDEVICEDESC);
	if (D3DD->GetCaps(&DX.D3DHD, &DX.D3DSD)) {
		log("  Error retrieving caps");
		return FXFALSE;
	}

	D3DD->Release();

	log("  Caps:");
	log("    dwDevCaps=               0x" << hex << setw(8) << setfill('0') << DX.D3DHD.dwDevCaps);
	log("    dpcTriCaps:");
	log("      dwMiscCaps=            0x" << setw(8) << setfill('0') << DX.D3DHD.dpcTriCaps.dwMiscCaps);
	log("      dwRasterCaps=          0x" << setw(8) << setfill('0') << DX.D3DHD.dpcTriCaps.dwRasterCaps);
	log("      dwZCmpCaps=            0x" << setw(8) << setfill('0') << DX.D3DHD.dpcTriCaps.dwZCmpCaps);
	log("      dwSrcBlendCaps=        0x" << setw(8) << setfill('0') << DX.D3DHD.dpcTriCaps.dwSrcBlendCaps);
	log("      dwDestBlendCaps=       0x" << setw(8) << setfill('0') << DX.D3DHD.dpcTriCaps.dwDestBlendCaps);
	log("      dwAlphaCmpCaps=        0x" << setw(8) << setfill('0') << DX.D3DHD.dpcTriCaps.dwAlphaCmpCaps);
	log("      dwShadeCaps=           0x" << setw(8) << setfill('0') << DX.D3DHD.dpcTriCaps.dwShadeCaps);
	log("      dwTextureCaps=         0x" << setw(8) << setfill('0') << DX.D3DHD.dpcTriCaps.dwTextureCaps);
	log("      dwTextureFilterCaps=   0x" << setw(8) << setfill('0') << DX.D3DHD.dpcTriCaps.dwTextureFilterCaps);
	log("      dwTextureBlendCaps=    0x" << setw(8) << setfill('0') << DX.D3DHD.dpcTriCaps.dwTextureBlendCaps);
	log("      dwTextureAddressCaps=  0x" << setw(8) << setfill('0') << DX.D3DHD.dpcTriCaps.dwTextureAddressCaps);
	log("      dwStippleWidth=        " << dec << DX.D3DHD.dpcTriCaps.dwStippleWidth);
	log("      dwStippleHeight=       " << DX.D3DHD.dpcTriCaps.dwStippleHeight);
	log("    dwDeviceRenderBitDepth=  " << DX.D3DHD.dwDeviceRenderBitDepth);
	log("    dwDeviceZBufferBitDepth= " << DX.D3DHD.dwDeviceZBufferBitDepth);
	log("    dwStencilCaps=           0x" << hex << setw(8) << setfill('0') << DX.D3DHD.dwStencilCaps);
	log("    dwFVFCaps=               0x" << setw(8) << setfill('0') << DX.D3DHD.dwFVFCaps);
	log("    dwTextureOpCaps=         0x" << setw(8) << setfill('0') << DX.D3DHD.dwTextureOpCaps);
	log("    wMaxTextureBlendStages=  " << dec << DX.D3DHD.wMaxTextureBlendStages);
	log("    wMaxSimultaneousTextures=" << dec << DX.D3DHD.wMaxSimultaneousTextures);

	return FXTRUE;
}

static HRESULT WINAPI EnumZBufferCallback(DDPIXELFORMAT *pddpf, VOID* pddpfDesired ) {

	DDPIXELFORMAT *ddpf = (DDPIXELFORMAT *)pddpfDesired;;


	if( pddpf->dwFlags == DDPF_ZBUFFER )    {
		log("  Found a Z-buffer format");

        // Return with D3DENUMRET_CANCEL to end the search.
		if( pddpf->dwZBufferBitDepth == ddpf->dwZBufferBitDepth ) {
//		if( pddpf->dwZBufferBitDepth == 24 ) {
			memcpy( pddpfDesired, pddpf, sizeof(DDPIXELFORMAT) );
			return D3DENUMRET_CANCEL;
		}
	} 

    // Return with D3DENUMRET_OK to continue the search.
    return D3DENUMRET_OK;
}


FxBool getzbuffer(DDPIXELFORMAT & ddpfZBuffer) {

	ddpfZBuffer.dwSize = 0;

	if (Settings.zbits == -1) {
		ddpfZBuffer.dwZBufferBitDepth = 16;
		DX.D3D->EnumZBufferFormats(IID_IDirect3DHALDevice, EnumZBufferCallback, (VOID*)&ddpfZBuffer );

		if (ddpfZBuffer.dwSize == 0) {
			log("  Could not create 16-bit W-Buffer");
			return FXFALSE;
		}

		depthbuf_lut[GR_DEPTHBUFFER_WBUFFER] = DEPTH_W;
		depthbuf_lut[GR_DEPTHBUFFER_WBUFFER_COMPARE_TO_BIAS] = DEPTH_W;
	} else if (Settings.zbits) {
		ddpfZBuffer.dwZBufferBitDepth = Settings.zbits;
		DX.D3D->EnumZBufferFormats(IID_IDirect3DHALDevice, EnumZBufferCallback, (VOID*)&ddpfZBuffer );

		if (ddpfZBuffer.dwSize == 0) {
			log("  Could not create " << Settings.zbits << " bit depth buffer");
			return FXFALSE;
		}

		int type;
		switch (Settings.zbits) {
		case 16: type = DEPTH_W_Z16; break;
		case 24: type = DEPTH_W_Z24; break;
		case 32: type = DEPTH_W_Z32; break;
		default: log("Bad registry entry: zbits (needs to be 16, 24, or 32 decimal)"); return FXFALSE;
		};

		depthbuf_lut[GR_DEPTHBUFFER_WBUFFER] = type;
		depthbuf_lut[GR_DEPTHBUFFER_WBUFFER_COMPARE_TO_BIAS] = type;

	} else {
		if (DX.D3DHD.dpcTriCaps.dwRasterCaps & D3DPRASTERCAPS_WBUFFER) {
			ddpfZBuffer.dwZBufferBitDepth = 16;
			DX.D3D->EnumZBufferFormats(IID_IDirect3DHALDevice, EnumZBufferCallback, (VOID*)&ddpfZBuffer );
	
			if (ddpfZBuffer.dwSize == 0) {
				log("  Could not create 16-bit W-Buffer");
				return FXFALSE;
			}
	
			depthbuf_lut[GR_DEPTHBUFFER_WBUFFER] = DEPTH_W;
			depthbuf_lut[GR_DEPTHBUFFER_WBUFFER_COMPARE_TO_BIAS] = DEPTH_W;
		} else {
			ddpfZBuffer.dwZBufferBitDepth = 24;
			DX.D3D->EnumZBufferFormats(IID_IDirect3DHALDevice, EnumZBufferCallback, (VOID*)&ddpfZBuffer );
	
			if (ddpfZBuffer.dwSize > 0) {
				Voodoo.Zdepth = 24;
				depthbuf_lut[GR_DEPTHBUFFER_WBUFFER] = DEPTH_W_Z24;
				depthbuf_lut[GR_DEPTHBUFFER_WBUFFER_COMPARE_TO_BIAS] = DEPTH_W_Z24;
				log("  Found a 24 bit depth buffer");
			} else {
				ddpfZBuffer.dwZBufferBitDepth = 32;
				DX.D3D->EnumZBufferFormats(IID_IDirect3DHALDevice, EnumZBufferCallback, (VOID*)&ddpfZBuffer );
		
				if (ddpfZBuffer.dwSize > 0) {
					Voodoo.Zdepth = 32;
					depthbuf_lut[GR_DEPTHBUFFER_WBUFFER] = DEPTH_W_Z32;
					depthbuf_lut[GR_DEPTHBUFFER_WBUFFER_COMPARE_TO_BIAS] = DEPTH_W_Z32;
					log("  Found a 32 bit depth buffer");
				} else {
					ddpfZBuffer.dwZBufferBitDepth = 16;
					DX.D3D->EnumZBufferFormats(IID_IDirect3DHALDevice, EnumZBufferCallback, (VOID*)&ddpfZBuffer );
		
					if (ddpfZBuffer.dwSize > 0) {
						Voodoo.Zdepth = 16;
						depthbuf_lut[GR_DEPTHBUFFER_WBUFFER] = DEPTH_W_Z16;
						depthbuf_lut[GR_DEPTHBUFFER_WBUFFER_COMPARE_TO_BIAS] = DEPTH_W_Z16;
						log("  Found a 16 bit depth buffer");
					} else {
						log("  Error: could not find a depth buffer!");
						return FXFALSE;
					}
				}
			}
		}
	}

	depthbuf_lut[GR_DEPTHBUFFER_DISABLE] = DEPTH_D;
	depthbuf_lut[GR_DEPTHBUFFER_ZBUFFER] = DEPTH_Z;
	depthbuf_lut[GR_DEPTHBUFFER_ZBUFFER_COMPARE_TO_BIAS] = DEPTH_Z;

	return FXTRUE;
}