// Copyright (C) 1998-1999 Scott Cutler
// Please see the "readme.txt" file for license details

#include "include.h"

HRESULT CALLBACK EnumTextureCallback(LPDDPIXELFORMAT lpDDPixFmt, LPVOID lpUserArg) {
	log("    Texture pixel format:");
	log("      dwFlags=           0x" << hex << setw(8) << setfill('0') << lpDDPixFmt->dwFlags);
	log("      dwFourCC=          " << lpDDPixFmt->dwFourCC);
	log("      dwRGBBitCount=     " << dec << lpDDPixFmt->dwRGBBitCount);
	log("      dwRGBAlphaBitMask= 0x" << hex << setw(8) << setfill('0') << lpDDPixFmt->dwRGBAlphaBitMask);
	log("      dwRBitMask=        0x" << setw(8) << setfill('0') << lpDDPixFmt->dwRBitMask);
	log("      dwGBitMask=        0x" << setw(8) << setfill('0') << lpDDPixFmt->dwGBitMask);
	log("      dwBBitMask=        0x" << setw(8) << setfill('0') << lpDDPixFmt->dwBBitMask << dec);

	return 1;
}

BOOL CALLBACK EnumWindowsProc(HWND hwnd, LPARAM lparam) {
	char s[257];

	GetWindowText(hwnd, s, 257);
//	log(s);

	s[8] = 0;
	if (strcmp(s, "UltraHLE") == 0) {
		RECT r;
		
		GetWindowRect(hwnd, &r);
		MoveWindow(hwnd, r.left, r.top+100, (r.right-r.left), (r.bottom-r.top), 0);
	}

	return 1;
}

FX_ENTRY FxU32 FX_CALL grSstStatus( void ) {

	return 1;
}


FX_ENTRY void FX_CALL grSstIdle(void) {
	
}

FX_ENTRY FxBool FX_CALL grSstIsBusy( void ) {

	return 0;
}


BOOL WINAPI DDEnumCallbackEx(GUID FAR *pGUID, LPSTR pDriverDescription, LPSTR pDriverName, LPVOID pContext, HMONITOR hm) {

	if(pGUID) memcpy(pContext, pGUID, sizeof(GUID));

	return D3DENUMRET_OK;
}







FX_ENTRY FxBool FX_CALL grSstWinOpen(FxU32 hWnd, GrScreenResolution_t screen_resolution, GrScreenRefresh_t refresh_rate, GrColorFormat_t color_format, GrOriginLocation_t origin_location, int nColBuffers, int nAuxBuffers) {
	log("Called grSstWinOpen");
	log("  hWnd=" << hWnd);
	log("  res=" << screen_resolution);
	log("  refresh=" << refresh_rate);
	log("  color format=" << color_format);
	log("  origin=" << origin_location);
	log("  # col buffers=" << nColBuffers);
	log("  # aux buffers=" << nAuxBuffers);

	if (Voodoo.openwindow) grSstWinClose();

	switch (screen_resolution) {
	case GR_RESOLUTION_320x200:		Voodoo.width=320;	Voodoo.height=200;	break;
	case GR_RESOLUTION_320x240:		Voodoo.width=320;	Voodoo.height=240;	break;
	case GR_RESOLUTION_400x256:		Voodoo.width=400;	Voodoo.height=256;	break;
	case GR_RESOLUTION_512x384:		Voodoo.width=512;	Voodoo.height=384;	break;
	case GR_RESOLUTION_640x200:		Voodoo.width=640;	Voodoo.height=200;	break;
	case GR_RESOLUTION_640x350:		Voodoo.width=640;	Voodoo.height=350;	break;
	case GR_RESOLUTION_640x400:		Voodoo.width=640;	Voodoo.height=400;	break;
	case GR_RESOLUTION_NONE:
	case GR_RESOLUTION_640x480:		Voodoo.width=640;	Voodoo.height=480;	break;
	case GR_RESOLUTION_800x600:		Voodoo.width=800;	Voodoo.height=600;	break;
	case GR_RESOLUTION_960x720:		Voodoo.width=960;	Voodoo.height=720;	break;
	case GR_RESOLUTION_856x480:		Voodoo.width=856;	Voodoo.height=480;	break;
	case GR_RESOLUTION_512x256:		Voodoo.width=512;	Voodoo.height=256;	break;
	case GR_RESOLUTION_1024x768:	Voodoo.width=1024;	Voodoo.height=768;	break;
	case GR_RESOLUTION_1280x1024:	Voodoo.width=1280;	Voodoo.height=1024;	break;
	case GR_RESOLUTION_1600x1200:	Voodoo.width=1600;	Voodoo.height=1200;	break;
	case GR_RESOLUTION_400x300:		Voodoo.width=400;	Voodoo.height=300;	break;
	default:						log("Error: invalid resolution.\n"); return FXFALSE;
	}

	switch (refresh_rate) {
	case GR_REFRESH_60Hz:	Voodoo.refresh = 60;	break;
	case GR_REFRESH_70Hz:	Voodoo.refresh = 70;	break;
	case GR_REFRESH_72Hz:	Voodoo.refresh = 72;	break;
	case GR_REFRESH_75Hz:	Voodoo.refresh = 75;	break;
	case GR_REFRESH_80Hz:	Voodoo.refresh = 80;	break;
	case GR_REFRESH_90Hz:	Voodoo.refresh = 90;	break;
	case GR_REFRESH_100Hz:	Voodoo.refresh = 100;	break;
	case GR_REFRESH_85Hz:	Voodoo.refresh = 85;	break;
	case GR_REFRESH_120Hz:	Voodoo.refresh = 120;	break;
	case GR_REFRESH_NONE:	Voodoo.refresh = 0;	break;
	default:				log("Error: invalid refresh rate.\n"); return FXFALSE;
	}

	
	
	DX.hWnd = (HWND)hWnd;
//	_hWnd = 0;
	Voodoo.colorFormat = color_format;

	Voodoo.origin = origin_location;
	if (Voodoo.origin == GR_ORIGIN_ANY) Voodoo.origin = GR_ORIGIN_UPPER_LEFT;

	Voodoo.dbMode = GR_DEPTHBUFFER_DISABLE;

	Voodoo.texture = NO_TEXTURE;
	Voodoo.curtex = 0;

	vconv = vconv_lut[depthbuf_lut[Voodoo.dbMode]][Voodoo.origin][Voodoo.texture];

//	_nColBuffers = nColBuffers;
//	_nAuxBuffers = nAuxBuffers;

//	WNDCLASS wndClass = { CS_HREDRAW | CS_VREDRAW, WndProc, 0, 0, _hInstance, 0, 0, 0, 0, TEXT("MyWindow") };
	WNDCLASS wndClass = { CS_HREDRAW | CS_VREDRAW, DefWindowProc, 0, 0, _hInstance, 0, 0, 0, 0, TEXT("XGl200") };


	if(!DX.hWnd) {
		DX.hWnd = GetActiveWindow();

		char wndName[256];

		GetWindowText(DX.hWnd, wndName, sizeof(wndName));
		log("  Used window name='" << wndName << "'");
	}

	if (!DX.hWnd) {
		if (!RegisterClass( &wndClass )) {
			log("  Could not register window class");
			return FXFALSE;
		}

		if (!(DX.hWnd = CreateWindow("XGl200", "XGl200", WS_OVERLAPPEDWINDOW, 0, 0, Voodoo.width, Voodoo.height, 0, 0, _hInstance, 0 ))) {
			log("  Could not create window");
			return FXFALSE;
		}
		ShowWindow(DX.hWnd, SW_SHOWNORMAL);
		UpdateWindow(DX.hWnd);
	}

	// If DirectDrawCreate fails, user must not have DX 6 installed
	LPDIRECTDRAW DD;

	if (DirectDrawCreate(0, &DD, 0)) { 
		log("  Error: DirectDrawCreate(); failed\n");
		MessageBox(NULL, "Warning: This program requires DirectX 6.0.", "Error", MB_OK); 
		return FXFALSE; 
	}

	if (DD->QueryInterface(IID_IDirectDraw4, (LPVOID *)&DX.DD)) {
		log("  Error in QueryInterface");
		return FXFALSE;
	}

	if (DX.DD->SetCooperativeLevel(DX.hWnd, DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN | DDSCL_FPUSETUP)) {
		log("  Error in SetCooperativeLevel");
		return FXFALSE;
	}
	if (DX.DD->QueryInterface( IID_IDirect3D3, (VOID**)&DX.D3D)) {
		log("  Error in QueryInterface");
		return FXFALSE;
	}




	if (DX.DD->SetDisplayMode(Voodoo.width, Voodoo.height, 16, 0, 0)) {
		log("  Error in SetDisplayMode");
		return FXFALSE;
	}

	EnumWindows(EnumWindowsProc, 0);

	DDPIXELFORMAT ddpfZBuffer;
	if (getzbuffer(ddpfZBuffer) != FXTRUE) return FXFALSE;


	DDSURFACEDESC2 ddsd;
    DDSCAPS2 ddscaps;

	memset(&ddsd, 0, sizeof(DDSURFACEDESC2));
	ddsd.dwSize = sizeof(DDSURFACEDESC2);
	ddsd.dwFlags = DDSD_CAPS | DDSD_BACKBUFFERCOUNT;
	ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE | DDSCAPS_FLIP | DDSCAPS_COMPLEX | DDSCAPS_3DDEVICE;
	ddsd.dwBackBufferCount = Settings.backbuffers;

	if (DX.DD->CreateSurface(&ddsd, &DX.DDSPrimary, NULL)) {
		log("  Error in CreateSurface");
		return FXFALSE;
	}
    // Get a pointer to the back buffer
	ddscaps.dwCaps = DDSCAPS_BACKBUFFER;
	if (DX.DDSPrimary->GetAttachedSurface(&ddscaps, &DX.DDSRender)) {
		log("  Error in GetAttachedSurface");
		return FXFALSE;
	}



	if (getcaps() == FXFALSE) return FXFALSE;



	memset(&ddsd, 0, sizeof(DDSURFACEDESC2));
	ddsd.dwSize = sizeof(DDSURFACEDESC2);
	ddsd.dwFlags        = DDSD_CAPS|DDSD_WIDTH|DDSD_HEIGHT|DDSD_PIXELFORMAT;
	ddsd.ddsCaps.dwCaps = DDSCAPS_ZBUFFER | DDSCAPS_VIDEOMEMORY;
	ddsd.dwWidth        = Voodoo.width;
	ddsd.dwHeight       = Voodoo.height;
	memcpy( &ddsd.ddpfPixelFormat, &ddpfZBuffer, sizeof(DDPIXELFORMAT) ); 

	if(DX.DD->CreateSurface(&ddsd, &DX.DDSZBuffer, NULL)) {
		log(" Error in CreateSurface ");
		return FXFALSE;
	}

	if(DX.DDSRender->AddAttachedSurface(DX.DDSZBuffer)) {
		log("  Error in AddAttachedSurface");
		return FXFALSE;
	}

	if (DX.D3D->CreateDevice(IID_IDirect3DHALDevice, DX.DDSRender, &DX.D3DD, NULL)) {
		log("  Error in CreateDevice");
		return FXFALSE;
	}


	Voodoo.viewport.dwSize = sizeof(D3DVIEWPORT2);
	Voodoo.viewport.dwX = 0;
	Voodoo.viewport.dwY = 0;
	Voodoo.viewport.dwWidth = Voodoo.width;
	Voodoo.viewport.dwHeight = Voodoo.height;
	Voodoo.viewport.dvClipX = 0;
	Voodoo.viewport.dvClipY = 0;
	Voodoo.viewport.dvClipWidth = float(Voodoo.width);
	Voodoo.viewport.dvClipHeight = float(Voodoo.height);
	Voodoo.viewport.dvMinZ = 0;
	Voodoo.viewport.dvMaxZ = 1;

	if (DX.D3D->CreateViewport(&DX.D3DViewport, NULL)) {
		log("  Error in CreateViewport");
		return FXFALSE;
	}
	if (DX.D3DD->AddViewport(DX.D3DViewport)) {
		log("  Error in AddViewport");
		return FXFALSE;
	}
	if (DX.D3DViewport->SetViewport2(&Voodoo.viewport)) {
		log("  Error in SetViewport2 in grSstWinOpen");
		return FXFALSE;
	}
	if (DX.D3DD->SetCurrentViewport(DX.D3DViewport)) {
		log("  Error in SetCurrentViewport");
		return FXFALSE;
	}




	if (Settings.aa == 1) {
		DX.D3DD->SetRenderState(D3DRENDERSTATE_EDGEANTIALIAS, TRUE);
	} else if (Settings.aa == 2) {
		DX.D3DD->SetRenderState(D3DRENDERSTATE_ANTIALIAS, D3DANTIALIAS_SORTINDEPENDENT);
//		DX.D3DD->SetRenderState(D3DRENDERSTATE_ANTIALIAS, D3DANTIALIAS_SORTDEPENDENT);
	}


	grBufferClear(0, 0, 0);
	grBufferSwap(0);
	grBufferClear(0, 0, 0);
	grBufferSwap(0);
	grBufferClear(0, 0, 0);
	grBufferSwap(0);



	DX.D3DD->EnumTextureFormats(EnumTextureCallback, 0);


	getcolor = iterated;

	table_init();



//	D3DRENDERSTATETYPE
	DX.D3DD->SetRenderState(D3DRENDERSTATE_TEXTUREPERSPECTIVE, TRUE);
//	DX.D3DD->SetRenderState(D3DRENDERSTATE_WRAPU, TRUE);
//	DX.D3DD->SetRenderState(D3DRENDERSTATE_WRAPV, TRUE);
//	DX.D3DD->SetRenderState(D3DRENDERSTATE_ZENABLE, D3DZB_TRUE);
	DX.D3DD->SetRenderState(D3DRENDERSTATE_ALPHABLENDENABLE, TRUE);
	DX.D3DD->SetRenderState(D3DRENDERSTATE_CULLMODE, D3DCULL_NONE);
//	DX.D3DD->SetRenderState();
//	DX.D3DD->SetRenderState(D3DRENDERSTATE_DITHERENABLE, TRUE);
	DX.D3DD->SetRenderState(D3DRENDERSTATE_TEXTUREMIN, D3DFILTER_LINEAR);
	DX.D3DD->SetRenderState(D3DRENDERSTATE_TEXTUREMAG, D3DFILTER_LINEAR);
	DX.D3DD->SetRenderState(D3DRENDERSTATE_FOGCOLOR, 0x00000000);
//	DX.D3DD->SetRenderState(D3DRENDERSTATE_TEXTUREMAPBLEND, D3DTBLEND_DECAL);
	DX.D3DD->SetRenderState(D3DRENDERSTATE_SHADEMODE, D3DSHADE_GOURAUD);
	DX.D3DD->SetRenderState(D3DRENDERSTATE_SUBPIXEL, TRUE);


//	DX.D3DD->SetRenderState(D3DRENDERSTATE_TEXTUREMIN, D3DFILTER_MIPLINEAR);
//	DX.D3DD->SetRenderState(D3DRENDERSTATE_TEXTUREMAG, D3DFILTER_MIPLINEAR);

	DX.D3DD->SetTextureStageState(0, D3DTSS_MINFILTER, D3DTFG_POINT);
	DX.D3DD->SetTextureStageState(0, D3DTSS_MAGFILTER, D3DTFG_POINT);
//	DX.D3DD->SetTextureStageState(0, D3DTSS_MIPFILTER, D3DTFP_LINEAR);
//	DX.D3DD->SetTextureStageState(0, D3DTSS_MIPFILTER, D3DTFP_POINT);

//	DX.D3DD->SetRenderState(D3DRENDERSTATE_SRCBLEND, D3DPBLENDCAPS_ONE);
//	DX.D3DD->SetRenderState(D3DRENDERSTATE_DESTBLEND, D3DPBLENDCAPS_ZERO);


//	grColorMask(TRUE, TRUE);					// ?
	grDitherMode(GR_DITHER_4x4);
	grDepthBufferFunction(GR_CMP_LEQUAL);
	grDepthBufferMode(GR_DEPTHBUFFER_DISABLE);
	grColorCombine(GR_COMBINE_FUNCTION_SCALE_OTHER, GR_COMBINE_FACTOR_ONE, GR_COMBINE_LOCAL_ITERATED, GR_COMBINE_OTHER_ITERATED, 0);
	grTexClampMode(0, GR_TEXTURECLAMP_WRAP, GR_TEXTURECLAMP_WRAP);
	grConstantColorValue(0xFFFFFFFF);


//	Voodoo.lastpolytype = D3DPT_TRIANGLELIST;
//	_lpD3DD->Begin(D3DPT_TRIANGLELIST, D3DFVF_TLVERTEX, D3DDP_DONOTLIGHT | D3DDP_WAIT);

//	ShowCursor(FALSE);
	SetCursorPos(3600, 2400);

	log("  Finished grSstWinOpen successfully");

	Voodoo.openwindow = 1;


	return FXTRUE;
//	return FXFALSE;
}

/* Important */
FX_ENTRY void FX_CALL grSstWinClose( void ) {
	log("Called grSstWinClose");

	if (Voodoo.openwindow) {
		DX.D3DD->EndScene();

		DX.D3DViewport->Release();
		DX.D3DD->Release();
		DX.DDSPrimary->Release();

		DX.DD->RestoreDisplayMode();

		DX.D3D->Release();

		DX.DD->SetCooperativeLevel(DX.hWnd, DDSCL_NORMAL);
		DX.DD->Release();

		Voodoo.openwindow = 0;
	}


//	ShowCursor(TRUE);

//	_lpD3DFrame->DestroyObjects();
}


/* Important */
FX_ENTRY void FX_CALL grSstSelect(int which_sst ) {
	log("Called grSstSelect: sst=" << which_sst);

	if (_errorFnc && (which_sst != 0))
		_errorFnc("Invalid board selected", FXFALSE); // Error if board 0 is not selected.
}

/* Important */
FX_ENTRY FxU32 FX_CALL grSstScreenHeight( void ) {
	log("Called grSstScreenHeight");

	return Voodoo.height;
}

/* Important */
FX_ENTRY FxU32 FX_CALL grSstScreenWidth( void ) {
	log("Called grSstScreenWidth");

	return Voodoo.width;
}

FX_ENTRY FxBool FX_CALL grSstQueryHardware( GrHwConfiguration *hwconfig ) {
	log("Called grSstQueryHardware");

	Voodoo.openwindow = 0;

	hwconfig->num_sst = 1; // One subsystem...
	hwconfig->SSTs[0].type = GR_SSTTYPE_VOODOO; // ...of Voodoo type
	hwconfig->SSTs[0].sstBoard.VoodooConfig.fbRam = Voodoo.fbRam; // This many megs for the frame buffer
	hwconfig->SSTs[0].sstBoard.VoodooConfig.fbiRev = 1; // Revision number... not sure what this should be.
	hwconfig->SSTs[0].sstBoard.VoodooConfig.nTexelfx = 1; // 1 virtual TexelFX chip installed
	hwconfig->SSTs[0].sstBoard.VoodooConfig.sliDetect = FXFALSE; // Not SLI
	hwconfig->SSTs[0].sstBoard.VoodooConfig.tmuConfig[0].tmuRev = 1; // Revision number... not sure what this should be. 
	hwconfig->SSTs[0].sstBoard.VoodooConfig.tmuConfig[0].tmuRam = Voodoo.tmuRam; // This many megs for the texture unit

	return FXTRUE;
}

/* Important */
FX_ENTRY FxBool FX_CALL grSstQueryBoards( GrHwConfiguration *hwconfig ) {
	log("Called grSstQueryBoards");

	memset(hwconfig, 0, sizeof(GrHwConfiguration)); // Added 2/2/99
	hwconfig->num_sst = 1; // We have one virtual board installed

	return FXTRUE;
}


/* Only for Marble32 */
FX_ENTRY FxBool FX_CALL grSstControl(FxU32 i) {
	vlog("Called grSstControl: value=" << i);

	return FXTRUE;
}
